require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    if(defined(&_KERNEL)) {
	eval 'sub atomic_cas_uint {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_uint(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_uint);
	eval 'sub atomic_cas_ulong {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_ulong(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_ulong);
	eval 'sub atomic_cas_ptr {
	    my($_p, $_e, $_n) = @_;
    	    eval q( &_atomic_cas_ptr(($_p), ($_e), ($_n)));
	}' unless defined(&atomic_cas_ptr);
	eval 'sub def_atomic_swap {
	    my($_f, $_t, $_c) = @_;
    	    eval q( &static  &inline $_t $_f( &volatile $_t * &p, $_t  &v) { $_t  &e; $_t  &r;  &r = ($_t)* &p;  &do {  &e =  &r;  &r = $_c( &p,  &e,  &v); }  &while ( &r !=  &e);  &return ( &r); });
	}' unless defined(&def_atomic_swap);
	undef(&def_atomic_swap) if defined(&def_atomic_swap);
	eval 'sub atomic_swap_uint {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_uint($_p, $_v));
	}' unless defined(&atomic_swap_uint);
	eval 'sub atomic_swap_ulong {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_ulong($_p, $_v));
	}' unless defined(&atomic_swap_ulong);
	eval 'sub atomic_swap_ptr {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_ptr($_p, $_v));
	}' unless defined(&atomic_swap_ptr);
	eval 'sub def_atomic_op_nv {
	    my($_f, $_t, $_c, $_op) = @_;
    	    eval q( &static  &inline $_t $_f( &volatile $_t * &p, $_t  &v) { $_t  &e,  &r,  &f;  &r = * &p;  &do {  &e =  &r;  &f =  &e $_op  &v;  &r = $_c( &p,  &e,  &f); }  &while ( &r !=  &e);  &return ( &f); });
	}' unless defined(&def_atomic_op_nv);
	undef(&def_atomic_op_nv) if defined(&def_atomic_op_nv);
	eval 'sub atomic_add_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_int_nv($_p, $_v));
	}' unless defined(&atomic_add_int_nv);
	eval 'sub atomic_add_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_long_nv($_p, $_v));
	}' unless defined(&atomic_add_long_nv);
	eval 'sub atomic_sub_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_int_nv($_p, $_v));
	}' unless defined(&atomic_sub_int_nv);
	eval 'sub atomic_sub_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_long_nv($_p, $_v));
	}' unless defined(&atomic_sub_long_nv);
	eval 'sub atomic_setbits_int {
	    my($uip,$v) = @_;
    	    eval q({ my $e,  &r;  &r = *$uip;  &do {  $e =  &r;  &r =  &atomic_cas_uint($uip,  $e,  $e | $v); }  &while ( &r !=  $e); });
	}' unless defined(&atomic_setbits_int);
	eval 'sub atomic_clearbits_int {
	    my($uip,$v) = @_;
    	    eval q({ my $e,  &r;  &r = *$uip;  &do {  $e =  &r;  &r =  &atomic_cas_uint($uip,  $e,  $e & ~$v); }  &while ( &r !=  $e); });
	}' unless defined(&atomic_clearbits_int);
	eval 'sub membar_enter () {
	    eval q( &membar( &StoreLoad| &StoreStore));
	}' unless defined(&membar_enter);
	eval 'sub membar_exit () {
	    eval q( &membar( &LoadStore| &StoreStore));
	}' unless defined(&membar_exit);
	eval 'sub membar_producer () {
	    eval q( &membar( &StoreStore));
	}' unless defined(&membar_producer);
	eval 'sub membar_consumer () {
	    eval q( &membar( &LoadLoad));
	}' unless defined(&membar_consumer);
	eval 'sub membar_sync () {
	    eval q( &membar( &Sync));
	}' unless defined(&membar_sync);
    }
}
1;
